SET SERVEROUTPUT ON
DECLARE
  v_major INTEGER := 0;
  v_minor INTEGER := 0;
  v_patch INTEGER := 0;
  
  v_req_major CONSTANT INTEGER  := 2;
  v_req_minor CONSTANT INTEGER  := 0;
  v_req_patch CONSTANT INTEGER  := 0;
  
  v_next_major CONSTANT INTEGER := 2;
  v_next_minor CONSTANT INTEGER := 0;
  v_next_patch CONSTANT INTEGER := 1;
 
BEGIN
  DBMS_OUTPUT.PUT_LINE('Applying Patch...');
  -- Get schema version
  SELECT MAJOR,MINOR,PATCH INTO v_major,v_minor,v_patch FROM T_SCHEMA_VERS WHERE ROWNUM <=1;
  -- check version
  IF v_major = v_req_major AND  v_minor = v_req_minor AND v_patch = v_req_patch THEN
     -- apply patch
     EXECUTE IMMEDIATE 'ALTER TABLE T_JOB MODIFY (SUBMIT_TIME TIMESTAMP DEFAULT SYSTIMESTAMP AT TIME ZONE ''+00:00'')';
     EXECUTE IMMEDIATE 'ALTER TABLE T_TRACE MODIFY (TRACE_TIMESTAMP TIMESTAMP DEFAULT SYSTIMESTAMP AT TIME ZONE ''+00:00'')';
     -- Modify T_TRACE AUTO INC Trigger
     EXECUTE IMMEDIATE ('CREATE OR REPLACE TRIGGER trace_trace_id_auto_inc
                         BEFORE INSERT ON t_trace FOR EACH ROW WHEN (new.trace_id IS NULL) BEGIN
                         SELECT trace_trace_id_seq.nextval INTO :new.trace_id from dual;END;');
     -- Update Schema Version
     UPDATE T_SCHEMA_VERS SET MAJOR=v_next_major, MINOR=v_next_minor, PATCH=v_next_patch; 
     DBMS_OUTPUT.PUT_LINE('SUCCESS: Patch applied. New version is ' || TO_CHAR(v_next_major) || '.' || TO_CHAR(v_next_minor) || '.' || TO_CHAR(v_next_patch) );
  ELSIF v_major = v_next_major AND  v_minor = v_next_minor AND v_patch = v_next_patch THEN
     DBMS_OUTPUT.PUT_LINE('SUCCESS: Patch already applied. Version is ' || TO_CHAR(v_next_major) || '.' || TO_CHAR(v_next_minor) || '.' || TO_CHAR(v_next_patch) );
  ELSE
     DBMS_OUTPUT.PUT_LINE('ERROR: Cannot apply patch. Version ' || TO_CHAR(v_major) || '.' || TO_CHAR(v_minor) || '.' || TO_CHAR(v_patch) || ' does not match the required one (' || TO_CHAR(v_req_major) || '.' || TO_CHAR(v_req_minor) || '.' || TO_CHAR(v_req_patch) || ')');
  END IF;
END;
/
