SET SERVEROUTPUT ON

--
-- Main
DECLARE
  v_major INTEGER := 0;
  v_minor INTEGER := 0;
  v_patch INTEGER := 0;
  
  v_req_major     CONSTANT INTEGER  := 2;
  v_req_minor     CONSTANT INTEGER  := 1;
  v_req_patch     CONSTANT INTEGER  := 0;
  
  v_constraint INTEGER := 0;
BEGIN

  DBMS_OUTPUT.PUT_LINE('Applying Patch...');
  -- Get schema version
  SELECT MAJOR,MINOR,PATCH INTO v_major,v_minor,v_patch FROM T_SCHEMA_VERS WHERE ROWNUM <=1;
  -- check version
  IF v_major = v_req_major AND v_minor = v_req_minor AND v_patch = v_req_patch THEN
    -- check if constraint is already there
    SELECT COUNT(CONSTRAINT_NAME) INTO v_constraint FROM USER_CONSTRAINTS WHERE CONSTRAINT_NAME = 'CHANNEL_SOURCE_DEST_UQ';
    
    IF v_constraint = 1 THEN
      DBMS_OUTPUT.PUT_LINE('SUCCESS: Constraint already existed.');
    ELSE
      -- Add T_CHANNEL unique source/dest pair constraint
      EXECUTE IMMEDIATE ('ALTER TABLE t_channel ADD CONSTRAINT channel_source_dest_uq UNIQUE (source_site, dest_site)');
      DBMS_OUTPUT.PUT_LINE('SUCCESS: Patch applied.');
    END IF;
  ELSE
    DBMS_OUTPUT.PUT_LINE('ERROR: Cannot apply patch. Version ' || TO_CHAR(v_major) || '.' || TO_CHAR(v_minor) || '.' || TO_CHAR(v_patch) || ' does not match the required one (' || TO_CHAR(v_req_major) || '.' || TO_CHAR(v_req_minor) || '.' || TO_CHAR(v_req_patch) || ')');
  END IF;
END;
/
